Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## org.jboss.aop
Interface DynamicAOPStrategy

All Known Implementing Classes:
  HotSwapStrategy

public interface DynamicAOPStrategy

Strategy for dealing with dynamic aop related operations. Decides what must be done when a dynamic operation changes an interceptor chain. For dynamic operation we mean the addition or removal of:

- an `org.jboss.aop.advice.AdviceBinding` to `org.jboss.aop.AspectManager`.
- an interceptor or interceptor stack to `org.jboss.aop.InstanceAdvisor`.

Author:
  Flavia Rainone

Method Summary
`DynamicTransformationObserver` | `getDynamicTransformationObserver(javassist.CtClass clazz)` Returns a dynamic transformation observer to be notified of the dynamic events during the `clazz` transformation.
`org.jboss.aop.InterceptorChainObserver` | `getInterceptorChainObserver(Class clazz)` Return an interceptor chain observer for `clazz`.
`JoinpointClassifier` | `getJoinpointClassifier()` Returns a joinpoint classifier compatible to the strategy.
`void` | `interceptorChainsUpdated()` Notifies the strategy that one or more interceptor chains in the system may have been updated.

Method Detail

### getInterceptorChainObserver

    public org.jboss.aop.InterceptorChainObserver getInterceptorChainObserver(Class clazz)

  Return an interceptor chain observer for `clazz`. This observer is notified of any changes to an interceptor chain related to `clazz`.

  Parameters:
    `clazz` - the `clazz` whose interceptor chains will be observed by the observer returned.
  Returns:
    the interceptor chain observer for `clazz`. May return null if the strategy doesn't require an observer at all.

### interceptorChainsUpdated

    public void interceptorChainsUpdated()

  Notifies the strategy that one or more interceptor chains in the system may have been updated. It is up to this method to take appropriate actions when this situation occurs.

### getJoinpointClassifier

    public JoinpointClassifier getJoinpointClassifier()

  Returns a joinpoint classifier compatible to the strategy. This joinpoint classifier is the one that should be used by `org.jboss.aop.instrument.Instrumentor` instances to classify joinpoints. This classification is fundamental to instrumentation algorithm to decide what to do to a joinpoint: prepare for future interception instrumentation or instrument for interception.

  Returns:
    an instance of `org.jboss.aop.instrument.JoinpointClassifier`.

### getDynamicTransformationObserver

    public DynamicTransformationObserver getDynamicTransformationObserver(javassist.CtClass clazz)

  Returns a dynamic transformation observer to be notified of the dynamic events during the `clazz` transformation.

  Parameters:
    `clazz` - the clazz whose transformation must be observed.
  See Also:
    `DynamicTransformationObserver`

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2004 JBoss Inc. All Rights Reserved.